// Borland C++ Builder
// Copyright (c) 1995, 2005 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Xsms.pas' rev: 10.00

#ifndef XsmsHPP
#define XsmsHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Gsm.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Connect.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Xsms
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSMSProtocolStatus { smspsEmpty, smspsOK, smspsNotComplete };
#pragma option pop

#pragma option push -b-
enum TSMSProtocolInsertStatus { smsprOK, smsprBadFragment, smsprFragmentDoesNotFit, smsprFragmentDifferentData };
#pragma option pop

#pragma option push -b-
enum TSMSProtocolOptions { smspoAddressing, smspoReference };
#pragma option pop

typedef Set<TSMSProtocolOptions, smspoAddressing, smspoReference>  TSMSProtocolOptionsSet;

class DELPHICLASS TSMSProtocol;
class PASCALIMPLEMENTATION TSMSProtocol : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString fData;
	Classes::TStrings* fFragments;
	TSMSProtocolStatus fStatus;
	int fReference;
	System::TDateTime fStamp;
	AnsiString __fastcall GetFragment(int Index);
	int __fastcall GetFragmentCount(void);
	AnsiString __fastcall GetData();
	void __fastcall SetData(const AnsiString Value);
	void __fastcall SetReference(const int Value);
	int __fastcall GetInsertedCount(void);
	
protected:
	int fLastInserted;
	virtual void __fastcall EncodeFragments(void) = 0 ;
	void __fastcall CheckCompleted(void);
	void __fastcall SetStamp(void);
	
public:
	__fastcall virtual TSMSProtocol(void);
	__fastcall virtual ~TSMSProtocol(void);
	virtual void __fastcall Clear(void);
	__property int FragmentCount = {read=GetFragmentCount, nodefault};
	__property int InsertedCount = {read=GetInsertedCount, nodefault};
	__property int LastInserted = {read=fLastInserted, nodefault};
	__property AnsiString Fragments[int Index] = {read=GetFragment};
	__property TSMSProtocolStatus Status = {read=fStatus, nodefault};
	__property System::TDateTime Stamp = {read=fStamp};
	virtual TSMSProtocolInsertStatus __fastcall InsertFragment(const AnsiString aFragment) = 0 ;
	
__published:
	__property AnsiString Data = {read=GetData, write=SetData};
	__property int Reference = {read=fReference, write=SetReference, nodefault};
};


class DELPHICLASS TSMSProtocol2;
class PASCALIMPLEMENTATION TSMSProtocol2 : public TSMSProtocol 
{
	typedef TSMSProtocol inherited;
	
private:
	Word fSourceAddress;
	Word fDestinationAddress;
	TSMSProtocolOptionsSet fOptions;
	void __fastcall SetDestinationAddress(const Word Value);
	void __fastcall SetSourceAddress(const Word Value);
	void __fastcall SetOptions(const TSMSProtocolOptionsSet Value);
	
__published:
	__property Word SourceAddress = {read=fSourceAddress, write=SetSourceAddress, nodefault};
	__property Word DestinationAddress = {read=fDestinationAddress, write=SetDestinationAddress, nodefault};
	__property TSMSProtocolOptionsSet Options = {read=fOptions, write=SetOptions, nodefault};
public:
	#pragma option push -w-inl
	/* TSMSProtocol.Create */ inline __fastcall virtual TSMSProtocol2(void) : TSMSProtocol() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMSProtocol.Destroy */ inline __fastcall virtual ~TSMSProtocol2(void) { }
	#pragma option pop
	
};


class DELPHICLASS TNBS;
class PASCALIMPLEMENTATION TNBS : public TSMSProtocol2 
{
	typedef TSMSProtocol2 inherited;
	
private:
	bool fBinary;
	AnsiString fOtherHeader;
	void __fastcall SetBinary(const bool Value);
	void __fastcall SetOtherHeader(const AnsiString Value);
	
protected:
	virtual void __fastcall EncodeFragments(void);
	
public:
	virtual TSMSProtocolInsertStatus __fastcall InsertFragment(const AnsiString aFragment);
	
__published:
	__property AnsiString OtherHeader = {read=fOtherHeader, write=SetOtherHeader};
	__property bool Binary = {read=fBinary, write=SetBinary, nodefault};
public:
	#pragma option push -w-inl
	/* TSMSProtocol.Create */ inline __fastcall virtual TNBS(void) : TSMSProtocol2() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMSProtocol.Destroy */ inline __fastcall virtual ~TNBS(void) { }
	#pragma option pop
	
};


class DELPHICLASS TIE;
class PASCALIMPLEMENTATION TIE : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Byte fIEI;
	AnsiString fIED;
	void __fastcall SetIED(const AnsiString Value);
	void __fastcall SetIEI(const Byte Value);
	
public:
	__property Byte IEI = {read=fIEI, write=SetIEI, nodefault};
	__property AnsiString IED = {read=fIED, write=SetIED};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TIE(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TIE(void) { }
	#pragma option pop
	
};


class DELPHICLASS TUDHProtocol;
class PASCALIMPLEMENTATION TUDHProtocol : public TSMSProtocol2 
{
	typedef TSMSProtocol2 inherited;
	
private:
	Contnrs::TObjectList* fIES;
	int fIESCounter;
	Byte fEncodeFlag;
	AnsiString __fastcall EncodeIEs();
	
protected:
	virtual void __fastcall EncodeFragments(void);
	virtual bool __fastcall GetNextIE(bool aReset, int aRemainingL, int aMaxL, TIE* &aIE);
	
public:
	__property Contnrs::TObjectList* IEs = {read=fIES};
	virtual TSMSProtocolInsertStatus __fastcall InsertFragment(const AnsiString aFragment);
	__fastcall virtual TUDHProtocol(void);
	__fastcall virtual ~TUDHProtocol(void);
	virtual void __fastcall Clear(void);
};


class DELPHICLASS TEMSUDHProtocol;
class PASCALIMPLEMENTATION TEMSUDHProtocol : public TUDHProtocol 
{
	typedef TUDHProtocol inherited;
	
private:
	Contnrs::TObjectList* fIEPending;
	int fIEPendingCounter;
	
protected:
	virtual bool __fastcall GetNextIE(bool aReset, int aRemainingL, int aMaxL, TIE* &aIE);
	
public:
	__fastcall virtual TEMSUDHProtocol(void);
	__fastcall virtual ~TEMSUDHProtocol(void);
};


class DELPHICLASS TSiemensOTA;
class PASCALIMPLEMENTATION TSiemensOTA : public TSMSProtocol 
{
	typedef TSMSProtocol inherited;
	
private:
	AnsiString fObjectType;
	AnsiString fObjectName;
	int fObjectSize;
	void __fastcall SetObjectName(const AnsiString Value);
	void __fastcall SetObjectType(const AnsiString Value);
	
protected:
	virtual void __fastcall EncodeFragments(void);
	
public:
	virtual TSMSProtocolInsertStatus __fastcall InsertFragment(const AnsiString aFragment);
	
__published:
	__property AnsiString ObjectName = {read=fObjectName, write=SetObjectName};
	__property AnsiString ObjectType = {read=fObjectType, write=SetObjectType};
public:
	#pragma option push -w-inl
	/* TSMSProtocol.Create */ inline __fastcall virtual TSiemensOTA(void) : TSMSProtocol() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMSProtocol.Destroy */ inline __fastcall virtual ~TSiemensOTA(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMSProtocolStack;
class PASCALIMPLEMENTATION TSMSProtocolStack : public Classes::TStringList 
{
	typedef Classes::TStringList inherited;
	
public:
	bool __fastcall ProcessSMS(Gsm::TSMS* aSMS, TSMSProtocol* &aId);
	void __fastcall RemoveSMSProtocol(TSMSProtocol* aId);
	void __fastcall CleanSMSProtocols(System::TDateTime aRelativeDT, bool aOnlyNotComplete);
public:
	#pragma option push -w-inl
	/* TStringList.Destroy */ inline __fastcall virtual ~TSMSProtocolStack(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMSProtocolStack(void) : Classes::TStringList() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TDirectoryRecordHeader { drhFull, drhPartial, drhNone };
#pragma option pop

class DELPHICLASS TDirectoryRecords;
class PASCALIMPLEMENTATION TDirectoryRecords : public Classes::TStringList 
{
	typedef Classes::TStringList inherited;
	
private:
	int fFoldingLength;
	AnsiString fKind;
	TDirectoryRecordHeader fHeader;
	Classes::TStrings* __fastcall GetParams(int Index);
	Classes::TStrings* __fastcall GetParamsOf(AnsiString aName);
	AnsiString __fastcall GetData();
	void __fastcall SetData(const AnsiString Value);
	
protected:
	virtual System::TObject* __fastcall GetObject(int Index);
	
__published:
	__property int FoldingLength = {read=fFoldingLength, write=fFoldingLength, nodefault};
	__property AnsiString Data = {read=GetData, write=SetData};
	__property AnsiString Kind = {read=fKind, write=fKind};
	__property TDirectoryRecordHeader Header = {read=fHeader, write=fHeader, nodefault};
	
public:
	__fastcall virtual ~TDirectoryRecords(void);
	__property Classes::TStrings* Params[int Index] = {read=GetParams};
	__property Classes::TStrings* ParamsOf[AnsiString aName] = {read=GetParamsOf};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TDirectoryRecords(void) : Classes::TStringList() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TSoundMelodyPatternScale { smps55Hz, smps110Hz, smps220Hz, smps440Hz, smps880Hz, smps1760Hz, smps3520Hz, smps7040Hz, smps14080Hz };
#pragma option pop

#pragma option push -b-
enum TSoundMelodyPatternNote { smgpnPause, smgpnC, smgpnCis, smgpnDes, smgpnD, smgpnDis, ssmgpnEs, mginE, smgpnEis, smgpnF, smgpnFis, smgpnGes, smgpnG, smgpnGis, smgpnAs, smgpnA, smgpnAis, smgpnB, smgpnH, smgpnHis };
#pragma option pop

#pragma option push -b-
enum TSoundMelodyPatternDuration { smgpdFull, smgpd2, smgpd4, smgpd8, smgpd16, smgpd32 };
#pragma option pop

#pragma option push -b-
enum TSoundMelodyPatternDurationSpecifier { smgpdsNoSpecial, smgpdsDotted, smgpdsDoubleDotted, smgpdsLength2_3 };
#pragma option pop

#pragma option push -b-
enum TSoundMelodyPatternStyle { smpsNatural, smpsContinuous, smpsStaccato };
#pragma option pop

struct TSoundMelodyPatternItem
{
	
public:
	TSoundMelodyPatternScale Scale;
	TSoundMelodyPatternNote Note;
	TSoundMelodyPatternDuration Duration;
	TSoundMelodyPatternDurationSpecifier DurationSpecifier;
	Byte Tempo;
	TSoundMelodyPatternStyle Style;
	Byte Volume;
	int Special;
} ;

typedef DynamicArray<TSoundMelodyPatternItem >  XSMS__11;

class DELPHICLASS TSoundMelody;
class PASCALIMPLEMENTATION TSoundMelody : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	void __fastcall AddLine(void);
	AnsiString __fastcall GetRTTTL();
	void __fastcall SetRTTTL(const AnsiString Value);
	
public:
	AnsiString Name;
	DynamicArray<TSoundMelodyPatternItem >  Pattern;
	__property AnsiString RTTTL = {read=GetRTTTL, write=SetRTTTL};
	__fastcall TSoundMelody(void);
	/*         class method */ static Word __fastcall DecodeBeatsPerMin(TMetaClass* vmt, Byte aBeats);
	/*         class method */ static Byte __fastcall EncodeBeatsPerMin(TMetaClass* vmt, Word aBeats);
	void __fastcall InitPattern(void);
	Classes::TStrings* __fastcall CreateStrings(void);
	void __fastcall AssignStrings(Classes::TStrings* Sg);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSoundMelody(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSmartMessage;
class PASCALIMPLEMENTATION TSmartMessage : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString __fastcall GetData();
	void __fastcall SetData(const AnsiString Value);
	
protected:
	virtual AnsiString __fastcall Encode(void) = 0 ;
	virtual void __fastcall Decode(const AnsiString Value) = 0 ;
	
public:
	/*         class method */ static TSmartMessage* __fastcall CreateSM(TMetaClass* vmt, const AnsiString aData, Word aPort);
	__fastcall virtual TSmartMessage(void);
	__property AnsiString Data = {read=GetData, write=SetData};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSmartMessage(void) { }
	#pragma option pop
	
};


typedef TMetaClass* TSmartMessageClass;

class DELPHICLASS TSMMIMEDirectory;
class PASCALIMPLEMENTATION TSMMIMEDirectory : public TSmartMessage 
{
	typedef TSmartMessage inherited;
	
private:
	TDirectoryRecords* fRecords;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__fastcall virtual TSMMIMEDirectory(void);
	__fastcall virtual ~TSMMIMEDirectory(void);
	__property TDirectoryRecords* Records = {read=fRecords};
};


class DELPHICLASS TSMvCard;
class PASCALIMPLEMENTATION TSMvCard : public TSMMIMEDirectory 
{
	typedef TSMMIMEDirectory inherited;
	
public:
	__fastcall virtual TSMvCard(void);
public:
	#pragma option push -w-inl
	/* TSMMIMEDirectory.Destroy */ inline __fastcall virtual ~TSMvCard(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMvCalendar;
class PASCALIMPLEMENTATION TSMvCalendar : public TSMMIMEDirectory 
{
	typedef TSMMIMEDirectory inherited;
	
public:
	__fastcall virtual TSMvCalendar(void);
public:
	#pragma option push -w-inl
	/* TSMMIMEDirectory.Destroy */ inline __fastcall virtual ~TSMvCalendar(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMOTABitmap;
class PASCALIMPLEMENTATION TSMOTABitmap : public TSmartMessage 
{
	typedef TSmartMessage inherited;
	
private:
	AnsiString fInfoFields;
	int fWidth;
	int fHeight;
	Byte fDepth;
	AnsiString fPalette;
	Classes::TList* fImages;
	int __fastcall GetAnimatedImageCount(void);
	Byte __fastcall GetInfoFieldCount(void);
	Byte __fastcall GetInfoFields(int Index);
	Types::TPoint __fastcall GetSize();
	void __fastcall SetAnimatedImageCount(const int Value);
	void __fastcall SetHeight(const int Value);
	void __fastcall SetInfoFieldCount(const Byte Value);
	void __fastcall SetInfoFields(int Index, const Byte Value);
	void __fastcall SetSize(const Types::TPoint &Value);
	void __fastcall SetWidth(const int Value);
	void __fastcall SetImage(int Index, Graphics::TBitmap* aBitmap);
	Graphics::TBitmap* __fastcall GetImage(int Index);
	void __fastcall AdjustInfoFields(void);
	void __fastcall AdjustSize(void);
	void __fastcall AdjustImages(int I);
	void __fastcall CheckSupport(void);
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property Byte InfoFieldCount = {read=GetInfoFieldCount, write=SetInfoFieldCount, nodefault};
	__property Byte InfoFields[int Index] = {read=GetInfoFields, write=SetInfoFields};
	__property int AnimatedImageCount = {read=GetAnimatedImageCount, write=SetAnimatedImageCount, nodefault};
	__property int Width = {read=fWidth, write=SetWidth, nodefault};
	__property int Height = {read=fHeight, write=SetHeight, nodefault};
	__property Types::TPoint Size = {read=GetSize, write=SetSize};
	__property Graphics::TBitmap* Images[int Index] = {read=GetImage, write=SetImage};
	__fastcall virtual TSMOTABitmap(void);
	__fastcall virtual ~TSMOTABitmap(void);
	void __fastcall ImportFromImage(Graphics::TBitmap* aBMP);
	void __fastcall ExportToImage(Graphics::TBitmap* aBMP);
};


class DELPHICLASS TSMScreenSaver;
class PASCALIMPLEMENTATION TSMScreenSaver : public TSMOTABitmap 
{
	typedef TSMOTABitmap inherited;
	
public:
	#pragma option push -w-inl
	/* TSMOTABitmap.Create */ inline __fastcall virtual TSMScreenSaver(void) : TSMOTABitmap() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMOTABitmap.Destroy */ inline __fastcall virtual ~TSMScreenSaver(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMCLIIcon;
class PASCALIMPLEMENTATION TSMCLIIcon : public TSMOTABitmap 
{
	typedef TSMOTABitmap inherited;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
public:
	#pragma option push -w-inl
	/* TSMOTABitmap.Create */ inline __fastcall virtual TSMCLIIcon(void) : TSMOTABitmap() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMOTABitmap.Destroy */ inline __fastcall virtual ~TSMCLIIcon(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMOperatorLogo;
class PASCALIMPLEMENTATION TSMOperatorLogo : public TSMOTABitmap 
{
	typedef TSMOTABitmap inherited;
	
private:
	Word fMCC;
	Byte fMNC;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property Word MCC = {read=fMCC, write=fMCC, nodefault};
	__property Byte MNC = {read=fMNC, write=fMNC, nodefault};
public:
	#pragma option push -w-inl
	/* TSMOTABitmap.Create */ inline __fastcall virtual TSMOperatorLogo(void) : TSMOTABitmap() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMOTABitmap.Destroy */ inline __fastcall virtual ~TSMOperatorLogo(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMTextISO;
class PASCALIMPLEMENTATION TSMTextISO : public TSmartMessage 
{
	typedef TSmartMessage inherited;
	
private:
	AnsiString fText;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property AnsiString Text = {read=fText, write=fText};
public:
	#pragma option push -w-inl
	/* TSmartMessage.Create */ inline __fastcall virtual TSMTextISO(void) : TSmartMessage() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMTextISO(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMTextUnicode;
class PASCALIMPLEMENTATION TSMTextUnicode : public TSmartMessage 
{
	typedef TSmartMessage inherited;
	
private:
	WideString fText;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property WideString Text = {read=fText, write=fText};
public:
	#pragma option push -w-inl
	/* TSmartMessage.Create */ inline __fastcall virtual TSMTextUnicode(void) : TSmartMessage() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMTextUnicode(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMProfile;
class PASCALIMPLEMENTATION TSMProfile : public TSMTextUnicode 
{
	typedef TSMTextUnicode inherited;
	
public:
	#pragma option push -w-inl
	/* TSmartMessage.Create */ inline __fastcall virtual TSMProfile(void) : TSMTextUnicode() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMProfile(void) { }
	#pragma option pop
	
};


class DELPHICLASS TBitStream;
class PASCALIMPLEMENTATION TBitStream : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString fData;
	Byte fBitCnt;
	int fByteCnt;
	bool fUnicodeFlag;
	void __fastcall SetData(const AnsiString Value);
	bool __fastcall GetEOF(void);
	
public:
	__property AnsiString Data = {read=fData, write=SetData};
	__property bool EOF = {read=GetEOF, nodefault};
	void __fastcall PutFillers(void);
	void __fastcall SkipFillers(void);
	bool __fastcall GetBit(void);
	void __fastcall PutBit(bool aVal);
	unsigned __fastcall GetBits(Byte aNum);
	void __fastcall PutBits(unsigned aVal, Byte aNum);
	void __fastcall Move(int aShift);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TBitStream(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TBitStream(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTPattern;
class PASCALIMPLEMENTATION TSMRTPattern : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Contnrs::TObjectList* fInstructions;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	Byte Id;
	Byte Loop;
	__property Contnrs::TObjectList* Instructions = {read=fInstructions};
	__fastcall virtual TSMRTPattern(void);
	__fastcall virtual ~TSMRTPattern(void);
};


class DELPHICLASS TSMRTInstruction;
class PASCALIMPLEMENTATION TSMRTInstruction : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS) = 0 ;
	virtual void __fastcall Encode(TBitStream* BS) = 0 ;
	
public:
	/*         class method */ static TSMRTInstruction* __fastcall CreateFromStream(TMetaClass* vmt, TBitStream* BS);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTInstruction(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTInstruction(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTNote;
class PASCALIMPLEMENTATION TSMRTNote : public TSMRTInstruction 
{
	typedef TSMRTInstruction inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	Byte Value;
	Byte Duration;
	Byte DurationSpecifier;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTNote(void) : TSMRTInstruction() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTNote(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTScale;
class PASCALIMPLEMENTATION TSMRTScale : public TSMRTInstruction 
{
	typedef TSMRTInstruction inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	Byte NoteScale;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTScale(void) : TSMRTInstruction() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTScale(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTStyle;
class PASCALIMPLEMENTATION TSMRTStyle : public TSMRTInstruction 
{
	typedef TSMRTInstruction inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	Byte Value;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTStyle(void) : TSMRTInstruction() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTStyle(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTTempo;
class PASCALIMPLEMENTATION TSMRTTempo : public TSMRTInstruction 
{
	typedef TSMRTInstruction inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	Byte BeatsPerMin;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTTempo(void) : TSMRTInstruction() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTTempo(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTVolume;
class PASCALIMPLEMENTATION TSMRTVolume : public TSMRTInstruction 
{
	typedef TSMRTInstruction inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	Byte Value;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTVolume(void) : TSMRTInstruction() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTVolume(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTCommandPart;
class PASCALIMPLEMENTATION TSMRTCommandPart : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	/*         class method */ static TSMRTCommandPart* __fastcall CreateFromStream(TMetaClass* vmt, TBitStream* BS);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTCommandPart(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTCommandPart(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTRingingTone;
class PASCALIMPLEMENTATION TSMRTRingingTone : public TSMRTCommandPart 
{
	typedef TSMRTCommandPart inherited;
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTRingingTone(void) : TSMRTCommandPart() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTRingingTone(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTUnicode;
class PASCALIMPLEMENTATION TSMRTUnicode : public TSMRTCommandPart 
{
	typedef TSMRTCommandPart inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTUnicode(void) : TSMRTCommandPart() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTUnicode(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTCancel;
class PASCALIMPLEMENTATION TSMRTCancel : public TSMRTCommandPart 
{
	typedef TSMRTCommandPart inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	Byte Specifier;
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTCancel(void) : TSMRTCommandPart() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTCancel(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTSound;
class PASCALIMPLEMENTATION TSMRTSound : public TSMRTCommandPart 
{
	typedef TSMRTCommandPart inherited;
	
private:
	void __fastcall UnsupportedSongType(void);
	
protected:
	void __fastcall EncodeType(TBitStream* BS);
	
public:
	/*         class method */ static TSMRTCommandPart* __fastcall CreateFromStream(TMetaClass* vmt, TBitStream* BS);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTSound(void) : TSMRTCommandPart() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTSound(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTTemporarySong;
class PASCALIMPLEMENTATION TSMRTTemporarySong : public TSMRTSound 
{
	typedef TSMRTSound inherited;
	
private:
	Contnrs::TObjectList* fPatterns;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	__property Contnrs::TObjectList* Patterns = {read=fPatterns};
	__fastcall virtual TSMRTTemporarySong(void);
	__fastcall virtual ~TSMRTTemporarySong(void);
};


class DELPHICLASS TSMRTBasicSong;
class PASCALIMPLEMENTATION TSMRTBasicSong : public TSMRTTemporarySong 
{
	typedef TSMRTTemporarySong inherited;
	
private:
	WideString fTitle;
	void __fastcall SetTitle(const WideString Value);
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	__property WideString Title = {read=fTitle, write=SetTitle};
public:
	#pragma option push -w-inl
	/* TSMRTTemporarySong.Create */ inline __fastcall virtual TSMRTBasicSong(void) : TSMRTTemporarySong() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TSMRTTemporarySong.Destroy */ inline __fastcall virtual ~TSMRTBasicSong(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTMidiSong;
class PASCALIMPLEMENTATION TSMRTMidiSong : public TSMRTSound 
{
	typedef TSMRTSound inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTMidiSong(void) : TSMRTSound() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTMidiSong(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTDigitisedSong;
class PASCALIMPLEMENTATION TSMRTDigitisedSong : public TSMRTSound 
{
	typedef TSMRTSound inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTDigitisedSong(void) : TSMRTSound() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTDigitisedSong(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTPolyphonicSong;
class PASCALIMPLEMENTATION TSMRTPolyphonicSong : public TSMRTSound 
{
	typedef TSMRTSound inherited;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMRTPolyphonicSong(void) : TSMRTSound() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMRTPolyphonicSong(void) { }
	#pragma option pop
	
};


class DELPHICLASS TSMRTCommand;
class PASCALIMPLEMENTATION TSMRTCommand : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Contnrs::TObjectList* fParts;
	
protected:
	virtual void __fastcall Decode(TBitStream* BS);
	virtual void __fastcall Encode(TBitStream* BS);
	
public:
	__property Contnrs::TObjectList* Parts = {read=fParts};
	__fastcall virtual TSMRTCommand(void);
	__fastcall virtual ~TSMRTCommand(void);
};


class DELPHICLASS TSMRingingTone;
class PASCALIMPLEMENTATION TSMRingingTone : public TSmartMessage 
{
	typedef TSmartMessage inherited;
	
private:
	Contnrs::TObjectList* fCommands;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property Contnrs::TObjectList* Commands = {read=fCommands};
	__fastcall virtual TSMRingingTone(void);
	__fastcall virtual ~TSMRingingTone(void);
	TSoundMelody* __fastcall CreateSoundMelody(void);
	void __fastcall AssignSoundMelody(TSoundMelody* Value);
};


class DELPHICLASS TSMMultipartMessage;
class PASCALIMPLEMENTATION TSMMultipartMessage : public TSmartMessage 
{
	typedef TSmartMessage inherited;
	
private:
	Contnrs::TObjectList* fMultiparts;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property Contnrs::TObjectList* Multiparts = {read=fMultiparts};
	__fastcall virtual TSMMultipartMessage(void);
	__fastcall virtual ~TSMMultipartMessage(void);
};


class DELPHICLASS TSMUnknown;
class PASCALIMPLEMENTATION TSMUnknown : public TSmartMessage 
{
	typedef TSmartMessage inherited;
	
private:
	AnsiString fData;
	Byte fMultipartType;
	
protected:
	__property Byte MultipartType = {read=fMultipartType, write=fMultipartType, nodefault};
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
public:
	#pragma option push -w-inl
	/* TSmartMessage.Create */ inline __fastcall virtual TSMUnknown(void) : TSmartMessage() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSMUnknown(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMS;
class PASCALIMPLEMENTATION TEMS : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Contnrs::TObjectList* fObjects;
	AnsiString fText;
	WideString __fastcall GetWideText();
	void __fastcall SetWideText(WideString Value);
	
public:
	__property AnsiString Text = {read=fText, write=fText};
	__property WideString WideText = {read=GetWideText, write=SetWideText};
	__property Contnrs::TObjectList* Objects = {read=fObjects};
	void __fastcall ReadFrom(TUDHProtocol* aProtocol);
	void __fastcall WriteTo(TUDHProtocol* aProtocol);
	__fastcall TEMS(void);
	__fastcall virtual ~TEMS(void);
};


typedef TMetaClass* TEMSObjectClass;

class DELPHICLASS TEMSObject;
class PASCALIMPLEMENTATION TEMSObject : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString __fastcall GetIED();
	void __fastcall SetIED(const AnsiString Value);
	
protected:
	virtual Byte __fastcall GetIEI(void);
	virtual AnsiString __fastcall Encode(void) = 0 ;
	virtual void __fastcall Decode(const AnsiString Value) = 0 ;
	
public:
	__property Byte IEI = {read=GetIEI, nodefault};
	__property AnsiString IED = {read=GetIED, write=SetIED};
	/*         class method */ static TEMSObject* __fastcall CreateFromIEI(TMetaClass* vmt, Byte aIEI);
	__fastcall virtual TEMSObject(void);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSObject(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSPosObject;
class PASCALIMPLEMENTATION TEMSPosObject : public TEMSObject 
{
	typedef TEMSObject inherited;
	
private:
	Byte fPos;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property Byte Pos = {read=fPos, write=fPos, nodefault};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSPosObject(void) : TEMSObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSPosObject(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSUnknown;
class PASCALIMPLEMENTATION TEMSUnknown : public TEMSObject 
{
	typedef TEMSObject inherited;
	
private:
	AnsiString fData;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property AnsiString Data = {read=fData, write=fData};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSUnknown(void) : TEMSObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSUnknown(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSTextFormat;
class PASCALIMPLEMENTATION TEMSTextFormat : public TEMSPosObject 
{
	typedef TEMSPosObject inherited;
	
private:
	Byte fLen;
	Byte fFormat;
	Byte fColor;
	void __fastcall SetFormatBool(int Index, const bool Value);
	void __fastcall SetFormatByte(int Index, const Byte Value);
	bool __fastcall GetFormatBool(int Index);
	Byte __fastcall GetFormatByte(int Index);
	Byte __fastcall GetColor(int Index);
	void __fastcall SetColor(int Index, const Byte Value);
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property Byte Len = {read=fLen, write=fLen, nodefault};
	__property Byte Alignment = {read=GetFormatByte, write=SetFormatByte, index=0, nodefault};
	__property Byte Size = {read=GetFormatByte, write=SetFormatByte, index=2, nodefault};
	__property bool Bold = {read=GetFormatBool, write=SetFormatBool, index=4, nodefault};
	__property bool Italic = {read=GetFormatBool, write=SetFormatBool, index=5, nodefault};
	__property bool Underlined = {read=GetFormatBool, write=SetFormatBool, index=6, nodefault};
	__property bool StrikeThrough = {read=GetFormatBool, write=SetFormatBool, index=7, nodefault};
	__property Byte ForegroundColor = {read=GetColor, write=SetColor, index=0, nodefault};
	__property Byte BackgroundColor = {read=GetColor, write=SetColor, index=4, nodefault};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSTextFormat(void) : TEMSPosObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSTextFormat(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSSoundPredef;
class PASCALIMPLEMENTATION TEMSSoundPredef : public TEMSPosObject 
{
	typedef TEMSPosObject inherited;
	
private:
	Byte fSoundId;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property Byte SoundId = {read=fSoundId, write=fSoundId, nodefault};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSSoundPredef(void) : TEMSPosObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSSoundPredef(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSSoundUserDef;
class PASCALIMPLEMENTATION TEMSSoundUserDef : public TEMSPosObject 
{
	typedef TEMSPosObject inherited;
	
private:
	TDirectoryRecords* fRecords;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property TDirectoryRecords* Records = {read=fRecords};
	
public:
	__fastcall virtual TEMSSoundUserDef(void);
	__fastcall virtual ~TEMSSoundUserDef(void);
	TSoundMelody* __fastcall CreateSoundMelody(void);
	void __fastcall AssignSoundMelody(TSoundMelody* Value, int X = 0x0, int Len = 0x7fffffff);
};


class DELPHICLASS TEMSAnimationPredef;
class PASCALIMPLEMENTATION TEMSAnimationPredef : public TEMSPosObject 
{
	typedef TEMSPosObject inherited;
	
private:
	Byte fAnimationId;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property Byte AnimationId = {read=fAnimationId, write=fAnimationId, nodefault};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSAnimationPredef(void) : TEMSPosObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSAnimationPredef(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSPicture;
class PASCALIMPLEMENTATION TEMSPicture : public TEMSPosObject 
{
	typedef TEMSPosObject inherited;
	
private:
	bool fNoImageSize;
	Graphics::TBitmap* fImage;
	int fMinHeight;
	int fMaxHeight;
	int fMinWidth;
	int fMaxWidth;
	int __fastcall GetHeight(void);
	int __fastcall GetWidth(void);
	void __fastcall SetHeight(const int Value);
	void __fastcall SetWidth(const int Value);
	void __fastcall SetImage(const Graphics::TBitmap* Value);
	void __fastcall AdjustImage(void);
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property int Width = {read=GetWidth, write=SetWidth, nodefault};
	__property int Height = {read=GetHeight, write=SetHeight, nodefault};
	__property Graphics::TBitmap* Image = {read=fImage, write=SetImage};
	
public:
	__fastcall virtual TEMSPicture(void);
	__fastcall virtual ~TEMSPicture(void);
	void __fastcall ImportFromImage(Graphics::TBitmap* aBMP);
};


class DELPHICLASS TEMSPictureVariable;
class PASCALIMPLEMENTATION TEMSPictureVariable : public TEMSPicture 
{
	typedef TEMSPicture inherited;
	
public:
	#pragma option push -w-inl
	/* TEMSPicture.Create */ inline __fastcall virtual TEMSPictureVariable(void) : TEMSPicture() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TEMSPicture.Destroy */ inline __fastcall virtual ~TEMSPictureVariable(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSPictureSmall;
class PASCALIMPLEMENTATION TEMSPictureSmall : public TEMSPicture 
{
	typedef TEMSPicture inherited;
	
public:
	__fastcall virtual TEMSPictureSmall(void);
public:
	#pragma option push -w-inl
	/* TEMSPicture.Destroy */ inline __fastcall virtual ~TEMSPictureSmall(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSPictureLarge;
class PASCALIMPLEMENTATION TEMSPictureLarge : public TEMSPicture 
{
	typedef TEMSPicture inherited;
	
public:
	__fastcall virtual TEMSPictureLarge(void);
public:
	#pragma option push -w-inl
	/* TEMSPicture.Destroy */ inline __fastcall virtual ~TEMSPictureLarge(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSAnimation;
class PASCALIMPLEMENTATION TEMSAnimation : public TEMSPosObject 
{
	typedef TEMSPosObject inherited;
	
private:
	Graphics::TBitmap* fImages[4];
	int fMinHeight;
	int fMaxHeight;
	int fMinWidth;
	int fMaxWidth;
	int __fastcall GetHeight(void);
	int __fastcall GetWidth(void);
	void __fastcall SetHeight(const int Value);
	void __fastcall SetWidth(const int Value);
	void __fastcall SetImage(int Index, const Graphics::TBitmap* Value);
	void __fastcall AdjustImages(void);
	void __fastcall CheckImageIndex(int I);
	Graphics::TBitmap* __fastcall GetImage(int Index);
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property int Width = {read=GetWidth, write=SetWidth, nodefault};
	__property int Height = {read=GetHeight, write=SetHeight, nodefault};
	
public:
	__property Graphics::TBitmap* Images[int Index] = {read=GetImage, write=SetImage};
	__fastcall virtual TEMSAnimation(void);
	__fastcall virtual ~TEMSAnimation(void);
	void __fastcall ImportFromImage(Graphics::TBitmap* aBMP);
	void __fastcall ExportToImage(Graphics::TBitmap* aBMP);
};


class DELPHICLASS TEMSAnimationSmall;
class PASCALIMPLEMENTATION TEMSAnimationSmall : public TEMSAnimation 
{
	typedef TEMSAnimation inherited;
	
public:
	__fastcall virtual TEMSAnimationSmall(void);
public:
	#pragma option push -w-inl
	/* TEMSAnimation.Destroy */ inline __fastcall virtual ~TEMSAnimationSmall(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSAnimationLarge;
class PASCALIMPLEMENTATION TEMSAnimationLarge : public TEMSAnimation 
{
	typedef TEMSAnimation inherited;
	
public:
	__fastcall virtual TEMSAnimationLarge(void);
public:
	#pragma option push -w-inl
	/* TEMSAnimation.Destroy */ inline __fastcall virtual ~TEMSAnimationLarge(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSUserPrompt;
class PASCALIMPLEMENTATION TEMSUserPrompt : public TEMSObject 
{
	typedef TEMSObject inherited;
	
private:
	Byte fNumOfObjects;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property Byte NumOfObjects = {read=fNumOfObjects, write=fNumOfObjects, nodefault};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSUserPrompt(void) : TEMSObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSUserPrompt(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSObjectDistributionIndicator;
class PASCALIMPLEMENTATION TEMSObjectDistributionIndicator : public TEMSObject 
{
	typedef TEMSObject inherited;
	
private:
	Byte fNumOfIE;
	Byte fAttrib;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
public:
	__property Byte NumOfIE = {read=fNumOfIE, write=fNumOfIE, nodefault};
	__property Byte Attrib = {read=fAttrib, write=fAttrib, nodefault};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSObjectDistributionIndicator(void) : TEMSObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSObjectDistributionIndicator(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSXObject;
class PASCALIMPLEMENTATION TEMSXObject : public TEMSObject 
{
	typedef TEMSObject inherited;
	
private:
	bool fHeaderFlag;
	Byte fReference;
	Word fPos;
	Word fDataLength;
	Byte fKind;
	Byte fAttrib;
	AnsiString fData;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property bool HeaderFlag = {read=fHeaderFlag, write=fHeaderFlag, nodefault};
	__property Byte Reference = {read=fReference, write=fReference, nodefault};
	__property Word Pos = {read=fPos, write=fPos, nodefault};
	__property Byte Attrib = {read=fAttrib, write=fAttrib, nodefault};
	__property Word DataLength = {read=fDataLength, write=fDataLength, nodefault};
	__property Byte Kind = {read=fKind, write=fKind, nodefault};
	__property AnsiString Data = {read=fData, write=fData};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSXObject(void) : TEMSObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSXObject(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSXObjectReused;
class PASCALIMPLEMENTATION TEMSXObjectReused : public TEMSObject 
{
	typedef TEMSObject inherited;
	
private:
	Byte fReference;
	Word fPos;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property Byte Reference = {read=fReference, write=fReference, nodefault};
	__property Word Pos = {read=fPos, write=fPos, nodefault};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSXObjectReused(void) : TEMSObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSXObjectReused(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSXObjectDataRequest;
class PASCALIMPLEMENTATION TEMSXObjectDataRequest : public TEMSObject 
{
	typedef TEMSObject inherited;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSXObjectDataRequest(void) : TEMSObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSXObjectDataRequest(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSWVGObject;
class PASCALIMPLEMENTATION TEMSWVGObject : public TEMSPosObject 
{
	typedef TEMSPosObject inherited;
	
private:
	AnsiString fData;
	
protected:
	virtual AnsiString __fastcall Encode();
	virtual void __fastcall Decode(const AnsiString Value);
	
__published:
	__property AnsiString Data = {read=fData, write=fData};
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSWVGObject(void) : TEMSPosObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSWVGObject(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSWVGObjectStandard;
class PASCALIMPLEMENTATION TEMSWVGObjectStandard : public TEMSWVGObject 
{
	typedef TEMSWVGObject inherited;
	
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSWVGObjectStandard(void) : TEMSWVGObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSWVGObjectStandard(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSWVGObjectCharSize;
class PASCALIMPLEMENTATION TEMSWVGObjectCharSize : public TEMSWVGObject 
{
	typedef TEMSWVGObject inherited;
	
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSWVGObjectCharSize(void) : TEMSWVGObject() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSWVGObjectCharSize(void) { }
	#pragma option pop
	
};


class DELPHICLASS TEMSCompressionControl;
class PASCALIMPLEMENTATION TEMSCompressionControl : public TEMSUnknown 
{
	typedef TEMSUnknown inherited;
	
public:
	#pragma option push -w-inl
	/* TEMSObject.Create */ inline __fastcall virtual TEMSCompressionControl(void) : TEMSUnknown() { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TEMSCompressionControl(void) { }
	#pragma option pop
	
};


typedef AnsiString XSMS__96[20];

typedef AnsiString XSMS__07[6];

typedef AnsiString XSMS__17[4];

typedef AnsiString XSMS__27[3];

//-- var, const, procedure ---------------------------------------------------
static const char smLF = '\xa';
static const char smCR = '\xd';
#define smLineDelimiter "\r\n"
static const char smSpace = '\x20';
#define smCommonDigit (Set<char, 0, 255> () << '\x30' << '\x31' << '\x32' << '\x33' << '\x34' << '\x35' << '\x36' << '\x37' << '\x38' << '\x39' )
#define smCommonHexDigit Set<char, 0, 255> () 
#define smCommonTelChar (Set<char, 0, 255> () << '\x20' << '\x23' << '\x2a' << '\x2d' << '\x30' << '\x31' << '\x32' << '\x33' << '\x34' << '\x35' << '\x36' << '\x37' << '\x38' << '\x39' << '\x40' << '\x43' << '\x4a' << '\x4d' << '\x50' << '\x51' << '\x52' << '\x53' << '\x54' << '\x55' << '\x56' << '\x57' << '\x58' << '\x59' << '\x60' << '\x63' << '\x6a' << '\x6d' << '\x70' << '\x71' << '\x72' << '\x73' << '\x74' << '\x75' << '\x76' << '\x77' )
static const char smBlinkOn = '\xbb';
static const char smBlinkOff = '\xab';
static const Shortint smPortMessage = 0x0;
static const Shortint smPortHttp = 0x50;
static const Byte smPortMIMEvCard = 0xe2;
static const Byte smPortMIMEvCalendar = 0xe4;
static const Word smPortCompactMessageCard = 0x157d;
static const Word smPortServiceCard = 0x157e;
static const Word smPortInternetAccessConfigurationData = 0x157f;
static const Word smPortReserved1 = 0x1580;
static const Word smPortRingingTone = 0x1581;
static const Word smPortOperatorLogo = 0x1582;
static const Word smPortCLILogo = 0x1583;
static const Word smPortDynamicMenuControlProtocol = 0x1584;
static const Word smPortReserved2 = 0x1585;
static const Word smPortReserved3 = 0x1586;
static const Word smPortMessageAccessProtocol = 0x1587;
static const Word smPortSimpleEmailNotification = 0x1588;
static const Word smPortReserved4 = 0x1589;
static const Word smPortMultiPart = 0x158a;
static const Word smPortTTML = 0x15cc;
static const Word smPortReserved6 = 0x15e1;
static const Word smPortReserved7 = 0x15e3;
static const Word smPortReserved8 = 0x2134;
static const Word smPortReserved9 = 0x2135;
static const Word smPortReserved10 = 0x2136;
static const Word smPortWAPWTASecureConnectionlessSessionService = 0xaf5;
static const Word smPortWAPWTASecureSessionService = 0xb6b;
static const Word smPortWAPPushConnectionlessSessionService_client = 0xb84;
static const Word smPortWAPPushSecureConnectionlessSessionService_client = 0xb85;
static const Word smPortWAPConnectionlessSessionService = 0x23f0;
static const Word smPortWAPSecureConnectionlessSessionService = 0x23f2;
static const Word smPortWAPSessionService = 0x23f1;
static const Word smPortWAPSecureSessionService = 0x23f3;
static const Word smPortWAPvCard = 0x23f4;
static const Word smPortWAPvCalendar = 0x23f5;
static const Word smPortWAPvCardSecure = 0x23f6;
static const Word smPortWAPvCalendarSecure = 0x23f7;
static const Shortint ieiConcatenatedSMRef8 = 0x0;
static const Shortint ieiSpecialSMSIndication = 0x1;
static const Shortint ieiApplicationPortAddressingScheme8 = 0x4;
static const Shortint ieiApplicationPortAddressingScheme16 = 0x5;
static const Shortint ieiSMSCControlParameters = 0x6;
static const Shortint ieiUDHSourceIndicator = 0x7;
static const Shortint ieiConcatenatedSMRef16 = 0x8;
static const Shortint ieiWirelessControlMessageProtocol = 0x9;
static const Shortint ieiTextFormattingEMSControl = 0xa;
static const Shortint ieiPredefinedSound = 0xb;
static const Shortint ieiUserDefinedSound = 0xc;
static const Shortint ieiPredefinedAnimation = 0xd;
static const Shortint ieiLargeAnimation = 0xe;
static const Shortint ieiSmallAnimation = 0xf;
static const Shortint ieiLargePicture = 0x10;
static const Shortint ieiSmallPicture = 0x11;
static const Shortint ieiVariablePicture = 0x12;
static const Shortint ieiUserPromptIndicator = 0x13;
static const Shortint ieiExtendedObjectEMSContent = 0x14;
static const Shortint ieiReusedExtendedObject = 0x15;
static const Shortint ieiCompressionControl = 0x16;
static const Shortint ieiObjectDistributionIndicator = 0x17;
static const Shortint ieiStandardWVGObject = 0x18;
static const Shortint ieiCharacterSizeWVGObject = 0x19;
static const Shortint ieiExtendedObjectDataRequestCommand = 0x1a;
static const Shortint ieiRFC822EMailHeader = 0x20;
static const Shortint ieiHyperlinkFormatElement = 0x21;
static const Shortint ieiReplyAddressElement = 0x22;
static const Byte smotabif0Cancatenation = 0x80;
static const Shortint smotabif0Compression = 0x40;
static const Shortint smotabif0Palette = 0x20;
static const Shortint smotabif0MaxSize = 0x10;
static const Shortint smotabif0NumberOfAnimatedIconsShift = 0x0;
static const Shortint smotabif0NumberOfAnimatedIcons = 0xf;
static const Shortint smotabif1BitmapVersionShift = 0x4;
static const Shortint smotabif1BitmapVersion = 0x70;
static const Shortint smrtpidPartA = 0x0;
static const Shortint smrtpidPartB = 0x1;
static const Shortint smrtpidPartC = 0x2;
static const Shortint smrtpidPartD = 0x3;
static const Shortint smrtiPatternHeader = 0x0;
static const Shortint smrtiNote = 0x1;
static const Shortint smrtiScale = 0x2;
static const Shortint smrtiStyle = 0x3;
static const Shortint smrtiTempo = 0x4;
static const Shortint smrtiVolume = 0x5;
static const Shortint smrtiNotePause = 0x0;
static const Shortint smrtiNoteC = 0x1;
static const Shortint smrtiNoteCis = 0x2;
static const Shortint smrtiNoteD = 0x3;
static const Shortint smrtiNoteDis = 0x4;
static const Shortint smrtiNoteE = 0x5;
static const Shortint smrtiNoteF = 0x6;
static const Shortint smrtiNoteFis = 0x7;
static const Shortint smrtiNoteG = 0x8;
static const Shortint smrtiNoteGis = 0x9;
static const Shortint smrtiNoteA = 0xa;
static const Shortint smrtiNoteAis = 0xb;
static const Shortint smrtiNoteH = 0xc;
static const Shortint smrtiDurationFull = 0x0;
static const Shortint smrtiDuration2 = 0x1;
static const Shortint smrtiDuration4 = 0x2;
static const Shortint smrtiDuration8 = 0x3;
static const Shortint smrtiDuration16 = 0x4;
static const Shortint smrtiDuration32 = 0x5;
static const Shortint smrtiDurationSpecNoSpecialDuration = 0x0;
static const Shortint smrtiDurationSpecDottedNote = 0x1;
static const Shortint smrtiDurationSpecDoubleDottedNote = 0x2;
static const Shortint smrtiDurationSpecLength2_3 = 0x3;
static const Shortint smrtiScale440Hz = 0x0;
static const Shortint smrtiScale880Hz = 0x1;
static const Shortint smrtiScale1760Hz = 0x2;
static const Shortint smrtiScale3520Hz = 0x3;
static const Shortint smrtiScaleDefault = 0x1;
static const Shortint smrtiStyleNatural = 0x0;
static const Shortint smrtiStyleContinuous = 0x1;
static const Shortint smrtiStyleStaccato = 0x2;
static const Shortint smrtiStyleDefault = 0x0;
static const Shortint smrtiTempoDefault = 0x8;
static const Shortint smrtiVolumeDefault = 0x7;
static const Shortint smmpTextISO = 0x0;
static const Shortint smmpTextUnicode = 0x1;
static const Shortint smmpBitmap = 0x2;
static const Shortint smmpRingingTone = 0x3;
static const Shortint smmpProfile = 0x4;
static const Shortint smmpReserved = 0x5;
static const Shortint smmpScreenSaver = 0x6;
static const Shortint emstxtAlignmentLeft = 0x0;
static const Shortint emstxtAlignmentCenter = 0x1;
static const Shortint emstxtAlignmentRight = 0x2;
static const Shortint emstxtAlignmentLanguage = 0x3;
static const Shortint emstxtSizeNormal = 0x0;
static const Shortint emstxtSizeLarge = 0x1;
static const Shortint emstxtSizeSmall = 0x2;
static const Shortint emsclBlack = 0x0;
static const Shortint emsclDarkGrey = 0x1;
static const Shortint emsclDarkRed = 0x2;
static const Shortint emsclDarkYellow = 0x3;
static const Shortint emsclDarkGreen = 0x4;
static const Shortint emsclDarkCyan = 0x5;
static const Shortint emsclDarkBlue = 0x6;
static const Shortint emsclDarkMagenta = 0x7;
static const Shortint emsclGrey = 0x8;
static const Shortint emsclWhite = 0x9;
static const Shortint emsclBrightRed = 0xa;
static const Shortint emsclBrightYellow = 0xb;
static const Shortint emsclBrightGreen = 0xc;
static const Shortint emsclBrightCyan = 0xd;
static const Shortint emsclBrightBlue = 0xe;
static const Shortint emsclBrightMagenta = 0xf;
static const Shortint emssndChimesHigh = 0x0;
static const Shortint emssndChimesLow = 0x1;
static const Shortint emssndDing = 0x2;
static const Shortint emssndTaDa = 0x3;
static const Shortint emssndNotify = 0x4;
static const Shortint emssndDrum = 0x5;
static const Shortint emssndClaps = 0x6;
static const Shortint emssndFanFar = 0x7;
static const Shortint emssndChordHigh = 0x8;
static const Shortint emssndChordLow = 0x9;
static const Shortint emsaniIronic = 0x0;
static const Shortint emsaniGlad = 0x1;
static const Shortint emsaniSceptic = 0x2;
static const Shortint emsaniSad = 0x3;
static const Shortint emsaniWOW = 0x4;
static const Shortint emsaniCrying = 0x5;
static const Shortint emsaniWinking = 0x6;
static const Shortint emsaniLaughing = 0x7;
static const Shortint emsaniIndifferent = 0x8;
static const Shortint emsaniKissing = 0x9;
static const Shortint emsaniConfused = 0xa;
static const Shortint emsaniTongue = 0xb;
static const Shortint emsaniAngry = 0xc;
static const Shortint emsaniWearingGlasses = 0xd;
static const Shortint eaniDevil = 0xe;
static const Shortint smpsBacklight = 0x1;
static const Shortint smpsVibration = 0x2;
static const Shortint smpsLed = 0x4;
static const Shortint emsodiaNoForwarding = 0x1;
static const Shortint emsxoPredefinedSound = 0x0;
static const Shortint emsxoiMelody = 0x1;
static const Shortint emsxoPictureBW = 0x2;
static const Shortint emsxoPictureGrey = 0x3;
static const Shortint emsxoPictureColor = 0x4;
static const Shortint emsxoPredefinedAnimation = 0x5;
static const Shortint emsxoAnimationBW = 0x6;
static const Shortint emsxoAnimationGrey = 0x7;
static const Shortint emsxoAnimationColor = 0x8;
static const Shortint emsxovCard = 0x9;
static const Shortint emsxovCalendar = 0xa;
static const Shortint emsxoWVGObjectStandard = 0xb;
static const Shortint emsxoPolyphonicMelody = 0xc;
static const Byte emsxoDataFormatDeliveryRequest = 0xff;
static const Shortint emsxaNoForwarding = 0x1;
static const Shortint emsxaUserPrompt = 0x2;
extern PACKAGE AnsiString SoundMelodyPatternNoteEnum[20];
extern PACKAGE AnsiString SoundMelodyPatternDurationEnum[6];
extern PACKAGE AnsiString SoundMelodyPatternDurationSpecifierEnum[4];
extern PACKAGE AnsiString SoundMelodyPatternStyleEnum[3];
extern PACKAGE Word SoundMelodyPatternTempoEnum[32];

}	/* namespace Xsms */
using namespace Xsms;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Xsms
